import random

SOURCE_PATH = ""

# Enables laplace smoothing for language model
_ENABLE_LAPLACE_SMOOTHING = False

# Language model pickle path
_LANGUAGE_MODEL_PICKLE_PATH = SOURCE_PATH + "language_model_pickles/"

# Stop words file
_STOPWORDS_FILE = SOURCE_PATH + "extras/stopwords.txt"

# Stop words file
_MORE_STOPWORDS_FILE = SOURCE_PATH + "extras/more_stopwords.txt"

############ TAGGER ################

# Pickle path for tags and terminal probs
_TERMINAL_PROBS_PICKLE_PATH = SOURCE_PATH + "terminal_pickles/"

# Generated titles output path
_OUTPUT_PATH = SOURCE_PATH + "output_ilp/"

# Language model webserver bigram delimeter
_WEBSERVER_DELIMITER = "%20"

# Tagger temporary file
_TAGGER_TEMP_FILE = "/tmp/tagger_temp.file"

# Tokenizer
_TOKENIZER = "/afs/csail.mit.edu/u/p/pawand/apps/mxpost/./penn_tokenizer.sed"

# MXPOST Tagger
_MXPOST_TAGGER = "/afs/csail.mit.edu/u/p/pawand/apps/mxpost/./mxpost"

# MXPOST Tagger Project
_MXPOST_TAGGER_PROJECT = "/afs/csail.mit.edu/u/p/pawand/apps/mxpost/tagger.project"

# Title tag language model laplace smoothing
_TITLE_TAG_LANGUAGE_MODEL_LAPLACE_SMOOTHING = True

# Threshold for word to tag mapping
_MINIMUM_TAGS_PER_WORD_IN_SECTION = 3

# Number of stop word occurences for it to be counted as a stopword cartesian pair
_MIN_STOPWORD_OCCURENCES = 5

# Pickle path
_PICKLE_PATH = SOURCE_PATH + "pickles/"

# SRILM path
_SRILM_PATH = "/afs/csail.mit.edu/group/sls/i386_linux26/local/srilm/bin/i686/"

# SRILM Language Model File Path
_SRILM_LM_FILE_PATH = SOURCE_PATH + "srilm_files/"

# Lock file directory
_ILP_LOCK_DIR = SOURCE_PATH + "ilp_lock_files/"

# Graph building file directory
_GRAPH_BUILDING_LOCK_DIR = SOURCE_PATH + "graph_lock_files/"

################ ROUGE ######################

# Rouge evaluation path
_ROUGE_EVAL_PATH = SOURCE_PATH + "rouge_eval/"

# Rouge perl script path
_ROUGE_PATH = "/afs/csail.mit.edu/u/p/pawand/apps/rouge/RELEASE-1.5.5/./ROUGE-1.5.5.pl"

# Rouge data path
_ROUGE_DATA_PATH = "/afs/csail.mit.edu/u/p/pawand/apps/rouge/RELEASE-1.5.5/data"

# Contstant
_NEGATIVE_INFINITY = -1000000000000.0

# Dummy index indicating there is no stopword
_NO_TRANS_INDEX = -1

############### PARSER ########################
_PARSER_CHARNIAK = "/afs/csail.mit.edu/u/p/pawand/apps/parser_charniak/PARSE/./parseIt -N1 /afs/csail.mit.edu/u/p/pawand/apps/parser_charniak/DATA/EN/"

############### LP_SOLVE ########################
_LP_SOLVE = "/afs/csail.mit.edu/u/p/pawand/apps/lpsolve/lp_solve"

# SRILM temp directory
def _SRILM_LM_TEMP_FILE_PATH():
    return "/tmp/srilm_temp_file_"+str(random.randint(0, 1000000))+"_"
