package main;

import java.util.List;

import readers.AlgorithmsReader;
import readers.CivilReader;
import readers.PhysicsReader;
import entities.Section;

public class GeneratePlainFiles {

	public GeneratePlainFiles() {
		super();
		// TODO Auto-generated constructor stub
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		List<Section> s;
		
		if(args.length < 1) {
			System.out.println("No dataset specified");
			 System.exit(1);
		}
		
		if(args[0].equals("physics")) {
			s = new PhysicsReader(false).readFile("/afs/csail.mit.edu/u/p/pawand/public_html/datasets/physics.xml");
		} else if(args[0].equals("algorithms")) {
			s = new AlgorithmsReader(false).readFile("/afs/csail.mit.edu/u/p/pawand/public_html/datasets/algorithms.xml");
		} else if(args[0].equals("civil")) {
		    s = new CivilReader(false).readFile("/afs/csail.mit.edu/u/p/pawand/public_html/datasets/civil.xml");
		} else {
			throw new RuntimeException("Invalid dataset specified");
		}
		
		System.out.println(HierarchicalFeatureVectorBuilder.GenerateFlatFile(s));	
	}

}
