package utilities;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;
import java.util.StringTokenizer;


public class Utils {
	static final String WORD_DELIMITERS = " \\#!@#$%^&*()+=[]{}|;:'\"<>,.?/`~-\t";
	static final String SENTENCE_DELIMITERS = ".;!?";
	public static final String END_OF_LINE = System.getProperty("line.separator");  
	 
	public static List<String> parseIntoWords(String s) {
		
		List<String> listString = new ArrayList<String>();
		// Parse and preserve delimiter chracters
		StringTokenizer sT = new StringTokenizer(s, WORD_DELIMITERS, false);
		while(sT.hasMoreTokens()) {
			listString.add(sT.nextToken());
		}
		
		return listString;
	}
	
	public static List<String> parseIntoSentences(String s) {
		List<String> listString = new ArrayList<String>();
		// Parse and preserve delimiter chracters
		StringTokenizer sT = new StringTokenizer(s, SENTENCE_DELIMITERS, false);
		while(sT.hasMoreTokens()) {
			listString.add(sT.nextToken());
		}
		return listString;		
	}
	
	public static String NormalizeString(String s) {
		s = s.toLowerCase();
		return s;
	}
	
	public static boolean isNumeric( String str ) {
	  try{
	    if( Double.isNaN( Double.valueOf( str ).doubleValue() ) )  return false;
	  }catch( Exception e ){
	    return false;
	  }
	  return true;
	}
	
	public static String stemWord(String word) {

		Stemmer stemmer = new Stemmer();
		for(int i=0; i < word.length(); i++) {
			stemmer.add(word.charAt(i));
		}
		stemmer.stem();
		return stemmer.toString();
	}
	
    public static String join(Collection s, String delimiter) {
        StringBuffer buffer = new StringBuffer();
        Iterator iter = s.iterator();
        while (iter.hasNext()) {
            buffer.append(iter.next());
            if (iter.hasNext()) {
                buffer.append(delimiter);
            }
        }
        return buffer.toString();
    }
}