import pickle, urllib, string

def load_pickle(path):
    f = open(path, 'r')
    g = pickle.load(f)
    f.close()
    return g
    
def save_pickle(path, g):
    f = open(path, 'w')
    pickle.dump(g, f)
    f.close()
    return

def load_web_pickle(url):
    print "* Downloading graph from server..."
    f = urllib.urlopen(url)
    print "* Loading graph...",
    g = pickle.load(f)
    print "Done"
    f.close()

    return g

def append_to_file_newline(filepath, text):
    outfile = open(filepath, 'a')
    outfile.write(text+"\n")
    outfile.close()

def nullfunc(arg):
    return

def fileexists(filepath):
    try:
        open(filepath, 'r').close()
        return True
    except IOError:
        return False

def strip_punc(text):
    new_text = ""
    for c in text:
        if not c in string.punctuation:
            new_text += c
    return new_text

class progressBar:
    def __init__(self, minValue = 0, maxValue = 10, totalWidth=12):
        self.progBar = "[]"   # This holds the progress bar string
        self.min = minValue
        self.max = maxValue
        self.span = maxValue - minValue
        self.width = totalWidth
        self.amount = 0       # When amount == max, we are 100% done 
        self.updateAmount(0)  # Build progress bar string
        
    def updateAmount(self, newAmount = 0):
        if newAmount < self.min: newAmount = self.min
        if newAmount > self.max: newAmount = self.max
        self.amount = newAmount
        
        # Figure out the new percent done, round to an integer
        diffFromMin = float(self.amount - self.min)
        percentDone = (diffFromMin / float(self.span)) * 100.0
        percentDone = round(percentDone)
        percentDone = int(percentDone)
        
        # Figure out how many hash bars the percentage should be
        allFull = self.width - 2
        numHashes = (percentDone / 100.0) * allFull
        numHashes = int(round(numHashes))
        
        # build a progress bar with hashes and spaces
        self.progBar = "[" + '#'*numHashes + ' '*(allFull-numHashes) + "]"
        
        # figure out where to put the percentage, roughly centered
        percentPlace = (len(self.progBar) / 2) - len(str(percentDone)) 
        percentString = str(percentDone) + "%"
        
        # slice the percentage into the bar
        self.progBar = self.progBar[0:percentPlace] + percentString + self.progBar[percentPlace+len(percentString):]

    def __str__(self):
        return str(self.progBar)
